//
// emf2eps Version 0.6
// Copyright(C) 2004-2008 Tsuyoshi Sadakata, all rights reserved.
//
// 2008/09/10 Version 0.6
//   * bZ[W{ɕύX
//   * z̏SȃR[hɕύX
//   * GUI̒
//
// 2004/04/26 Version 0.5
//   * EBhE̐FύX
//   * \[X𐮌`
//
// 2004/04/25 Version 0.4
//   * 쌠\ǉ
//   * rbg}bvP
//   * {^̖OύX
//
// 2004/04/25 Version 0.3
//   * @\
//   * BoundingBoxIɐݒ
//   * Nbv{[h̃rbg}bvf[^ɑΉ
//
// 2004/04/24 Version 0.2
//   * GUIɕύX
//
// 2004/04/22 Version 0.1
//   * t@[Xg[X
//   * CUI
//

// wb_t@C
#include <fstream>
#include <string>
#include <windows.h>
#include <mbstring.h>

// 萔
const char c_szClassName[] = {"emf2eps Version 0.6"};
const char c_szCopyright[] = {"Copyright (C) 2004-2008 Tsuyoshi Sadakata. All rights reserved."};
#define IDC_BUTTON1 100
#define IDC_BUTTON2 101
#define IDC_BUTTON3 102
#define IDC_COMBOBOX 103
#define IDC_LABEL1 104
#define IDC_LABEL2 105
#define IDM_OPENFILE 200
#define IDM_PASTE 201
#define IDM_ABOUT 202

// O[oϐ
HINSTANCE g_hInst = NULL;
HWND g_hwndMainWnd = NULL;
HWND g_hwndLabel1 = NULL;
HWND g_hwndLabel2 = NULL;
HWND g_hwndComboBox = NULL;
HWND g_hwndButton1 = NULL;
HWND g_hwndButton2 = NULL;
HWND g_hwndButton3 = NULL;

// ֐̃vg^Cv錾
LRESULT CALLBACK WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
int InitApp();
int InitMainWnd();
HACCEL InitAccel();
void MainWndOnCreate(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void MainWndOnCommand(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
bool openfiledlg(char *pFileName, int nSize);
bool savefiledlg(char *pFileName, int nSize);
bool convert2eps(HENHMETAFILE hEnhMetaFile, LPBITMAPINFO pBmpInfo, HBITMAP hBitmap, char *pFileName);

// WinMain֐
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow) {

  // Visual C++ 2005 oOp ({܂ރpXɑΉ)
  setlocale(LC_ALL, "Japanese");

  // CX^Xۑ
  g_hInst = hInst;

  // 
  if(!InitApp()) {
    return 0;
  }

  // EBhE쐬
  if(!InitMainWnd()) {
    return 0;
  }

  // EBhE\
  ShowWindow(g_hwndMainWnd, nCmdShow);
  UpdateWindow(g_hwndMainWnd);

  // ANZ[^e[u̍쐬
  HACCEL hAccel = InitAccel();

  // bZ[W[v
  MSG msg;
  BOOL bRet;
  while((bRet = GetMessage(&msg, NULL, 0, 0)) != 0) {
    if(bRet == -1) {
      break;
    }
    else {
      if((hAccel == NULL) || (TranslateAccelerator(g_hwndMainWnd, hAccel, &msg) == 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
      }
    }
  }

  // ANZ[^e[uj
  DestroyAcceleratorTable(hAccel);

  return (int)msg.wParam;
}

// EBhEvV[W
LRESULT CALLBACK WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {

  // bZ[W
  switch(uMsg) {
  // 
  case WM_CREATE:
    MainWndOnCreate(hWnd, uMsg, wParam, lParam);
    break;
  // {^
  case WM_COMMAND:
    MainWndOnCommand(hWnd, uMsg, wParam, lParam);
    break;
  // I
  case WM_DESTROY:
    PostQuitMessage(0);
    break;
  // ftHg
  default:
    return (DefWindowProc(hWnd, uMsg, wParam, lParam));
  }

  return 0;
}

// AvP[V̏
int InitApp() {
  // EBhENXo^
  WNDCLASSEX wcex;
  ZeroMemory(&wcex, sizeof(WNDCLASSEX));
  wcex.cbSize = sizeof(WNDCLASSEX);
  wcex.style = CS_HREDRAW | CS_VREDRAW;
  wcex.lpfnWndProc = WindowProc;
  wcex.cbClsExtra = 0;
  wcex.cbWndExtra = 0;
  wcex.hInstance = g_hInst;
  wcex.hIcon = (HICON)LoadImage(NULL, MAKEINTRESOURCE(IDI_APPLICATION), IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
  wcex.hCursor = (HICON)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW), IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
  wcex.hbrBackground = (HBRUSH)COLOR_BTNSHADOW;
  wcex.lpszMenuName = NULL;
  wcex.lpszClassName = c_szClassName;
  wcex.hIconSm = NULL;

  return (int)RegisterClassEx(&wcex);
}

// CEBhȄ
int InitMainWnd() {
  // CEBhE쐬
  g_hwndMainWnd = CreateWindowEx(0,
                                 c_szClassName,
                                 c_szClassName,
                                 WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_POPUPWINDOW,
                                 CW_USEDEFAULT,
                                 CW_USEDEFAULT,
                                 500,
                                 210,
                                 NULL,
                                 NULL,
                                 g_hInst,
                                 NULL);
  return ((g_hwndMainWnd != NULL) ? 1 : 0);
}

// ANZ[^̏
HACCEL InitAccel() {
  // ANZ[^̐ݒ
  ACCEL accels[3];
  // Ctrl + O
  accels[0].fVirt = FVIRTKEY | FCONTROL;
  accels[0].key = 0x4F; // O
  accels[0].cmd = IDM_OPENFILE;
  // Ctrl + V
  accels[1].fVirt = FVIRTKEY | FCONTROL;
  accels[1].key = 0x56; // V
  accels[1].cmd = IDM_PASTE;
  // Ctrl + A
  accels[2].fVirt = FVIRTKEY | FCONTROL;
  accels[2].key = 0x41; // A
  accels[2].cmd = IDM_ABOUT;
  // ANZ[^e[u쐬
  return CreateAcceleratorTable(accels, sizeof(accels)/sizeof(ACCEL));
}

// CEBhEWM_CREATȄ
void MainWndOnCreate(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  // x쐬
  g_hwndLabel1 = CreateWindowEx(0,
                                "Static",
                                "1. PostScriptv^IĂB",
                                WS_CHILD | WS_OVERLAPPED | WS_VISIBLE | SS_LEFTNOWORDWRAP,
                                10,
                                10,
                                300,
                                20,
                                hWnd,
                                (HMENU)IDC_LABEL1,
                                g_hInst,
                                NULL);
  g_hwndLabel2 = CreateWindowEx(0,
                                "Static",
                                "2. EMFt@Cϊꍇ́uJvA\r\n   Nbv{[h̃f[^ϊꍇ\r\n   u\tvĂB",
                                WS_CHILD | WS_OVERLAPPED | WS_VISIBLE | SS_LEFTNOWORDWRAP,
                                10,
                                70,
                                500,
                                120,
                                hWnd,
                                (HMENU)IDC_LABEL2,
                                g_hInst,
                                NULL);
  // R{{bNX쐬
  g_hwndComboBox = CreateWindowEx(WS_EX_CLIENTEDGE,
                                 "ComboBox",
                                 "",
                                  WS_CHILD | WS_OVERLAPPED | WS_VISIBLE | WS_TABSTOP | CBS_DROPDOWNLIST,
                                  10,
                                  35,
                                  350,
                                  300,
                                  hWnd,
                                  (HMENU)IDC_COMBOBOX,
                                  g_hInst,
                                  NULL);
  // {^쐬
  g_hwndButton1 = CreateWindowEx(0,
                                 "Button",
                                 "J (Ctrl+O)",
                                  WS_CHILD | WS_OVERLAPPED | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,
                                  10,
                                  140,
                                  150,
                                  25,
                                  hWnd,
                                  (HMENU)IDC_BUTTON1,
                                  g_hInst,
                                  NULL);
  // {^쐬
  g_hwndButton2 = CreateWindowEx(0,
                                 "Button",
                                 "\t (Ctrl+V)",
                                  WS_CHILD | WS_OVERLAPPED | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,
                                  170,
                                  140,
                                  150,
                                  25,
                                  hWnd,
                                  (HMENU)IDC_BUTTON2,
                                  g_hInst,
                                  NULL);
  // {^쐬
  g_hwndButton3 = CreateWindowEx(0,
                                 "Button",
                                 " (Ctrl+A)",
                                  WS_CHILD | WS_OVERLAPPED | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,
                                  330,
                                  140,
                                  150,
                                  25,
                                  hWnd,
                                  (HMENU)IDC_BUTTON3,
                                  g_hInst,
                                  NULL);

  // v^
  DWORD dwNeeded = 0, dwReturned = 0;
  EnumPrinters(PRINTER_ENUM_LOCAL | PRINTER_ENUM_NETWORK, NULL, 2, NULL, 0, &dwNeeded, &dwReturned);
  HGLOBAL hBuffer = GlobalAlloc(GHND, dwNeeded);
  LPBYTE pBuffer = (LPBYTE)GlobalLock(hBuffer);
  DWORD dwNeeded2 = 0, dwReturned2= 0;
  EnumPrinters(PRINTER_ENUM_LOCAL | PRINTER_ENUM_NETWORK, NULL, 2, pBuffer, dwNeeded, &dwNeeded2, &dwReturned2);

  // R{{bNXɃv^ǉ
  int index = -1;
  for(DWORD n = 0; n < dwReturned2; n++) {
    PRINTER_INFO_2 *ppi2 = (PRINTER_INFO_2*)(pBuffer + sizeof(PRINTER_INFO_2)*n);
    SendMessage(g_hwndComboBox, CB_ADDSTRING, 0, (LPARAM)ppi2->pPrinterName);
	if(index < 0) {
      if(_mbsstr((const unsigned char*)ppi2->pPrinterName, (const unsigned char*)"PostScript") != NULL) {
        index = (int)n;
	  }
    }
  }

  // "PostScript"Ƃ܂ރv^I
  if(index < 0) index = 0;
  SendMessage(g_hwndComboBox, CB_SETCURSEL, (WPARAM)index, 0);

  // q[v
  GlobalUnlock(hBuffer);
  GlobalFree(hBuffer);
}

// CEBhEWM_COMMAND̏
void MainWndOnCommand(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {

  // t@C
  char szFileName[MAX_PATH] = {""};
  // Nbv{[h̃tH[}bg`FbNp
  int format;
  UINT prilist[] = {CF_ENHMETAFILE, CF_DIB, CF_BITMAP};
  // EMFf[^̃nh
  HENHMETAFILE hEnhMetaFile = NULL;
  // BITMAPf[^̃nh
  HBITMAP hBitmap = NULL;
  // DIBf[^̃q[ṽnhƃ|C^
  HGLOBAL hMem = NULL;
  LPBITMAPINFO pDIB = NULL;
  // t@C̒
  int len;
  // \
  char szInformation[1024] = {""};

  // R}h
  switch(LOWORD(wParam)) {
  // {^1̏
  case IDC_BUTTON1:
  case IDM_OPENFILE:
    // t@CI_CAO\
    if(openfiledlg(szFileName, sizeof(szFileName))) {
      // EMFt@CJ
      hEnhMetaFile = GetEnhMetaFile(szFileName);
      // t@CJ
      if(hEnhMetaFile != NULL) {
        // gqemfepsɕύX
	    len = lstrlen(szFileName);
	    if((len >= 4) && (szFileName[len-4] == '.')) {
          szFileName[len-3] = '\0';
		}
		if(sizeof(szFileName)/sizeof(char)-1 > len-3) {
          lstrcat(szFileName, "eps");
		}
        // EPSɕϊ
        convert2eps(hEnhMetaFile, NULL, NULL, szFileName);
        // EMFf[^폜
        DeleteEnhMetaFile(hEnhMetaFile);
      }
    }
    break;
  // {^2̏
  case IDC_BUTTON2:
  case IDM_PASTE:
    // Nbv{[h`FbN
    format = GetPriorityClipboardFormat(prilist, sizeof(prilist)/sizeof(UINT));
    // ꍇ킯
    switch(format) {
    // EMFf[^̏ꍇ
    case CF_ENHMETAFILE:
      // Nbv{[hJ
      if(OpenClipboard(NULL) != 0) {
        // Nbv{[hEMFf[^ƂĂ
        hEnhMetaFile = (HENHMETAFILE)GetClipboardData(CF_ENHMETAFILE);
        CloseClipboard();
      }
      // Nbv{[hEMFf[^
      if(hEnhMetaFile != NULL) {
        // t@Cۑ_CAO\
        if(savefiledlg(szFileName, sizeof(szFileName))) {
          // EPSɕϊ
          convert2eps(hEnhMetaFile, NULL, NULL, szFileName);
        }
        // EMFf[^폜
        DeleteEnhMetaFile(hEnhMetaFile);
      }
      break;
    // DIBf[^̏ꍇ
    case CF_DIB:
      // Nbv{[hJ
      if(OpenClipboard(NULL) != 0) {
        // Nbv{[hDIBf[^ƂĂ
        hMem = (HGLOBAL)GetClipboardData(CF_DIB);
        CloseClipboard();
      }
      // Nbv{[hDIBf[^
      if(hMem != NULL) {
        // q[vbN
        pDIB = (LPBITMAPINFO)GlobalLock(hMem);
        if(pDIB != NULL) {
          // t@Cۑ_CAO\
          if(savefiledlg(szFileName, sizeof(szFileName))) {
            // EPSɕϊ
            convert2eps(NULL, pDIB, NULL, szFileName);
          }
          // q[vAbN
          GlobalUnlock(hMem);
        }
        // DIBf[^폜
        GlobalFree(hMem);
      }
      break;
    // BITMAPf[^̏ꍇ
    case CF_BITMAP:
      // Nbv{[hJ
      if(OpenClipboard(NULL) != 0) {
        // Nbv{[hBITMAPf[^ƂĂ
        hBitmap = (HBITMAP)GetClipboardData(CF_BITMAP);
        CloseClipboard();
      }
      // Nbv{[hBITMAPf[^
      if(hBitmap != NULL) {
        // t@Cۑ_CAO\
        if(savefiledlg(szFileName, sizeof(szFileName))) {
          // EPSɕϊ
          convert2eps(NULL, NULL, hBitmap, szFileName);
        }
        // BITMAPf[^폜
        DeleteObject(hBitmap);
      }
      break;
    }
    break;
  // {^3̏
  case IDC_BUTTON3:
  case IDM_ABOUT:
    // 쌠\
    lstrcpy(szInformation, c_szClassName);
    lstrcat(szInformation, "\r\n");
    lstrcat(szInformation, c_szCopyright);
    MessageBox(hWnd, szInformation, c_szClassName, MB_OK);
    break;
  default:
    break;
  }
}

// t@CI_CAO\
bool openfiledlg(char *pFileName, int nSize) {
  // `FbN
  if((pFileName == NULL) || (nSize < 1)) {
    return false;
  }
  // t@CI_CAOp\
  OPENFILENAME ofn;
  ZeroMemory(&ofn, sizeof(OPENFILENAME));
  ofn.lStructSize = sizeof(OPENFILENAME);
  ofn.hwndOwner = NULL;
  ofn.lpstrFilter = "EMFt@C (*.emf)\0*.emf\0\0";
  ofn.lpstrFile = pFileName;
  ofn.nMaxFile = nSize;
  ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_ENABLESIZING;
  ofn.lpstrDefExt = "emf";
  ofn.lpstrTitle = c_szClassName;
  // _CAO\
  return ((GetOpenFileName(&ofn) != 0) ? true : false);
}

// t@Cۑ_CAO\
bool savefiledlg(char *pFileName, int nSize) {
  // `FbN
  if((pFileName == NULL) || (nSize < 1)) {
    return false;
  }
  // t@CI_CAOp\
  OPENFILENAME ofn;
  ZeroMemory(&ofn, sizeof(OPENFILENAME));
  ofn.lStructSize = sizeof(OPENFILENAME);
  ofn.hwndOwner = NULL;
  ofn.lpstrFilter = "EPSt@C (*.eps)\0*.eps\0\0";
  ofn.lpstrFile = pFileName;
  ofn.nMaxFile = nSize;
  ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY | OFN_ENABLESIZING;
  ofn.lpstrDefExt = "eps";
  ofn.lpstrTitle = c_szClassName;
  // _CAO\
  return ((GetSaveFileName(&ofn) != 0) ? true : false);
}

// EMF,DIB,BITMAPf[^PSv^ֈ
bool convert2eps(HENHMETAFILE hEnhMetaFile, LPBITMAPINFO pBmpInfo, HBITMAP hBitmap, char *pFileName) {

  // `FbN
  if(((hEnhMetaFile == NULL) && (pBmpInfo == NULL) && (hBitmap == NULL)) || (pFileName == NULL)) {
    return false;
  }

  // ꎞt@C
  char szTempPath[MAX_PATH] = {""};
  GetTempPath(sizeof(szTempPath), szTempPath);
  char szTempFileName[MAX_PATH] = {""};
  GetTempFileName(szTempPath, "eps", GetTickCount(), szTempFileName);
  if(lstrlen(szTempFileName) < 1) {
    return false;
  }

  // v^R{{bNX擾
  char szPrinterName[1024] = {""};
  GetWindowText(g_hwndComboBox, szPrinterName, sizeof(szPrinterName));

  // 
  DOCINFO di;
  DEVMODE dm;
  ZeroMemory(&di, sizeof(DOCINFO));
  di.cbSize = sizeof(DOCINFO);
  di.lpszDocName = c_szClassName;
  di.lpszOutput = szTempFileName;
  di.lpszDatatype = "raw";
  ZeroMemory(&dm, sizeof(DEVMODE));
  dm.dmSpecVersion = DM_SPECVERSION;
  dm.dmSize = sizeof(DEVMODE);
  dm.dmFields = DM_PAPERSIZE | DM_COLOR;
  dm.dmPaperSize = DMPAPER_A4;
  dm.dmColor = DMCOLOR_COLOR;

  // v^̃foCXReLXg쐬
  HDC hdc = CreateDC(NULL, szPrinterName, NULL, NULL);
  if(hdc == NULL) {
    return false;
  }

  // Jn
  if(StartDoc(hdc, &di) > 0) {

    // ݒ𔽉f
    hdc = ResetDC(hdc, &dm);

    // y[WJn
    StartPage(hdc);

    // f[^̎ނŏꍇ킯
    int org_w = 0;
    int org_h = 0;
    HBITMAP hDDB = NULL;
    HDC hdc_mem = NULL;
    if(hEnhMetaFile != NULL) {
      // EMF̃wb_[擾
      ENHMETAHEADER emh;
      ZeroMemory(&emh, sizeof(ENHMETAHEADER));
      if(GetEnhMetaFileHeader(hEnhMetaFile, sizeof(ENHMETAHEADER), &emh) == 0) {
        EndPage(hdc);
        EndDoc(hdc);
        DeleteDC(hdc);
        return false;
      }
      // ƍ擾
      org_w = emh.rclFrame.right-emh.rclFrame.left;
      org_h = emh.rclFrame.bottom-emh.rclFrame.top;
    }
    else if(pBmpInfo != NULL) {
      // DIBDDB쐬
      hDDB = CreateDIBitmap(hdc, &(pBmpInfo->bmiHeader), CBM_INIT, (VOID**)((LPBYTE)pBmpInfo + pBmpInfo->bmiHeader.biSize), pBmpInfo, DIB_RGB_COLORS);
      if(hDDB == NULL) {
        EndPage(hdc);
        EndDoc(hdc);
        DeleteDC(hdc);
        return false;
      }
      // Rp`DC쐬Ċ֘At
      hdc_mem = CreateCompatibleDC(hdc);
      if(hdc_mem == NULL) {
        DeleteObject(hDDB);
        EndPage(hdc);
        EndDoc(hdc);
        DeleteDC(hdc);
        return false;
      }
      SelectObject(hdc_mem, hDDB);
      // rbg}bv̏𓾂
      BITMAP bm;
      ZeroMemory(&bm, sizeof(BITMAP));
      GetObject(hDDB, sizeof(BITMAP), (LPVOID)&bm);
      org_w = bm.bmWidth;
      org_h = bm.bmHeight;
    }
    else {
      // BITMAPpDC쐬
      hdc_mem = CreateCompatibleDC(hdc);
      if(hdc_mem == NULL) {
        EndPage(hdc);
        EndDoc(hdc);
        DeleteDC(hdc);
        return false;
      }
      SelectObject(hdc_mem, hBitmap);
      // rbg}bv̏𓾂
      BITMAP bm;
      ZeroMemory(&bm, sizeof(BITMAP));
      GetObject(hBitmap, sizeof(BITMAP), (LPVOID)&bm);
      org_w = bm.bmWidth;
      org_h = bm.bmHeight;
    }

    // foCXReLXg̕`̈̃TCYfoCXPʂŎ擾
    int w = GetDeviceCaps(hdc, PHYSICALWIDTH) - 2*GetDeviceCaps(hdc, PHYSICALOFFSETX);
    int h = GetDeviceCaps(hdc, PHYSICALHEIGHT) - 2*GetDeviceCaps(hdc, PHYSICALOFFSETY);

    // Rs[̋`̈foCXPʂŌvZ
    RECT rc;
    double rw = ((w != 0) ? (double)org_w/(double)w : 0.0);
    double rh = ((h != 0) ? (double)org_h/(double)h : 0.0);
    if((rw == 0.0) || (rh == 0.0)) {
      SetRect(&rc, 0, 0, 0, 0);
    }
    else {
      rc.left = 0;
      rc.top = 0;
      rc.right = (rw > rh) ? w : (int)((double)org_w/rh);
      rc.bottom = (rw > rh) ? (int)((double)org_h/rw): h;
    }

    // `
    if(hEnhMetaFile != NULL) {
      PlayEnhMetaFile(hdc, hEnhMetaFile, &rc);
    }
    else {
      StretchBlt(hdc, rc.left, rc.top, rc.right, rc.bottom, hdc_mem, 0, 0, org_w, org_h, SRCCOPY);
    }

    // 폜
    if(hdc_mem != NULL) {
      DeleteDC(hdc_mem);
    }
    if(hDDB != NULL) {
      DeleteObject(hDDB);
    }

    // BoundingBoxvZ
    int bleft = (int)(((double)GetDeviceCaps(hdc, PHYSICALOFFSETX)/(double)GetDeviceCaps(hdc, PHYSICALWIDTH))*210.0/0.351459 + 0.5) - 5;
    int bbottom = (int)(((double)(GetDeviceCaps(hdc, PHYSICALHEIGHT)-GetDeviceCaps(hdc, PHYSICALOFFSETY)-rc.bottom)/(double)GetDeviceCaps(hdc, PHYSICALHEIGHT))*297.0/0.351459 + 0.5) - 5;
    int bright = (int)(((double)(GetDeviceCaps(hdc, PHYSICALOFFSETX)+rc.right)/(double)GetDeviceCaps(hdc, PHYSICALWIDTH))*210.0/0.351459 + 0.5) + 5;
    int btop = (int)(((double)(GetDeviceCaps(hdc, PHYSICALHEIGHT)-GetDeviceCaps(hdc, PHYSICALOFFSETY))/(double)GetDeviceCaps(hdc, PHYSICALHEIGHT))*297.0/0.351459 + 0.5) + 5;

    // y[WI
    EndPage(hdc);

    // I
    EndDoc(hdc);

    // ꎞt@CJ
    std::string str;
    std::ifstream fin(szTempFileName);
    std::ofstream fout(pFileName);
    if(fin && fout) {
      while(!fin.eof()) {
        std::getline(fin, str);
        // oEfBO{bNX
        if(str.find("%%BoundingBox:") == 0) {
          char szBuffer[256];
          wsprintf(szBuffer, "%%%%BoundingBox: %d %d %d %d", bleft, bbottom, bright, btop);
          str = std::string(szBuffer);
        }
        fout << str << std::endl;
      }
    }
    fin.close();
    fout.close();

    // ꎞt@C폜
    DeleteFile(szTempFileName);
  }

  // n
  DeleteDC(hdc);

  return true;

}
